#ifndef RUNPAGEPRESENTER_HPP
#define RUNPAGEPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class RunPageView;

class RunPagePresenter : public touchgfx::Presenter, public ModelListener
{
public:
    RunPagePresenter(RunPageView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~RunPagePresenter() {};

private:
    RunPagePresenter();

    RunPageView& view;
};

#endif // RUNPAGEPRESENTER_HPP
